package com.zipcodewilmington.arrayutility;

import java.util.*;
import java.util.stream.Stream;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    private final T[] array;


    public ArrayUtility(T[] inputArray) {
        this.array = inputArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        Integer count = 0;
        List<T> list1 = new ArrayList<>(Arrays.asList(array));
        List<T> list2 = new ArrayList<>(Arrays.asList(arrayToMerge));
        Stream<T> mergedList = Stream.concat(list1.stream(), list2.stream());
        T[] mergedArr = (T[]) mergedList.toArray();
        for (T value : mergedArr){
            if (value.equals(valueToEvaluate)){
                mergedArr[count] = value;
                count++;
            }
        }
        return count;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T mostCommon = null;
        Integer count = Integer.MIN_VALUE;
        List<T> list1 = new ArrayList<>(Arrays.asList(array));
        List<T> list2 = new ArrayList<>((Arrays.asList(arrayToMerge)));
        Stream<T> mergedList = Stream.concat(list1.stream(), list2.stream());
        T[] mergedArr = (T[]) mergedList.toArray();
        for (T value : mergedArr){
            if (getNumberOfOccurrences(value) > count){
                count = getNumberOfOccurrences(value);
                mostCommon = value;
            }
        }
        return mostCommon;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        List<T> a2List = new ArrayList(Arrays.asList(array));
        Integer occurences = Collections.frequency(a2List, valueToEvaluate);

        return occurences;
    }

    public T[] removeValue(T valueToRemove) {
        int i=0;
        for (T arr : array){
            if (!arr.equals(valueToRemove)){
                array[i] = arr;
                i++;
            }
        }
        T[] array2 = Arrays.copyOf(array, i);
        return array2;
    }
}
